<template>
  <div class="app-container">
    <div class="filter-container filter-view">
      <div class="filter-flex-button">
        <el-button
          type="primary"
          @click="onClickIssue">
          ISSUE VOUCHER
        </el-button>
      </div>
    </div>
    <el-table
      v-loading="table.loading"
      :data="table.data">
      <el-table-column
        label="User E-mail"
        align="center"
        prop="userEmail"
        min-width="120"/>
      <el-table-column
        label="User"
        align="center"
        prop="userName"
        min-width="120"/>
      <el-table-column
        label="Voucher ID"
        align="center"
        prop="voucherId"
        min-width="140"/>
      <el-table-column
        label="Voucher Name"
        align="center"
        prop="voucherName"
        min-width="150"/>
      <el-table-column
        label="Voucher Type"
        align="center"
        prop="voucherType"
        min-width="120"/>
      <el-table-column
        label="Redemption Method"
        align="center"
        prop="redemptionMethod"
        min-width="160"/>
      <el-table-column
        label="DateTime"
        align="center"
        prop="dateTime"
        min-width="120"/>
      <el-table-column
        label="Status"
        align="center"
        prop="dataStatus"
        min-width="80"/>
    </el-table>
    <div class="right">
      <Pagination
        v-show="table.total > 0"
        :total="table.total"
        :page.sync="params.pageNum"
        :limit.sync="params.pageSize"
        @pagination="getTableData" />
    </div>
    <DialogIssue
      :visible="showIssueDialog"
      @hide="hideIssueDialog"/>
  </div>
</template>

<script>
import api from '../../http/api/voucher.js';
import Pagination from '@/components/Pagination';
import DialogIssue from './DialogIssue.vue';
export default {
  data() {
    return {
      params: {
        pageNum: 1,
        pageSize: 10,
        pageVo: {
          criteria: "",
          voucherStatus: "To Be Used"
        }
      },
      table: {
        data: [],
        total: 0,
        loading: false
      },
      showIssueDialog: false
    };
  },
  components: {DialogIssue, Pagination},
  created() {
    this.toSearch();
  },
  methods: {
    toSearch() {
      this.params.pageNum = 1;
      this.getTableData();
    },
    getTableData() {
      this.table.loading = true;
      api.getIssuanceVoucherPages(this.params).then(res => {
        if (res.data && res.data.totalRow) {
          this.table.data = res.data.records
          this.table.total = res.data.totalRow
        } else {
          this.table.data = []
          this.table.total = 0
        }
      }).catch(err => {
        this.$message({
          message: err,
          type: 'error'
        })
        this.table.data = []
        this.table.total = 0
      }).finally(() => {
        this.table.loading = false
      })
    },
    onClickIssue() {
      this.showIssueDialog = true;
    },
    hideIssueDialog(e) {
      this.showIssueDialog = false;
      if (e) {
        this.toSearch();
      }
    }
  }
}
</script>

<style scoped>

</style>